;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; File:    SHRINK.ASM
;; Author:  Patrick T. Hurley
;; Date:    06-03-92 02:26pm
;; Version: 1.0
;;
;; This code is released into the public domain.
;; your welcome to do whatever you want with it.
;;
;; This was a quicky don't make fun of my dirty asm
;;
		IDEAL
                MODEL LARGE, PROLOG
                ; NOTE: the PROLOG language type is just like LARGE, C
                ; except for the naming convention.  It does not have
                ; '_' prepended to the proc names

GROUP           DGROUP  ASMDATA

;                          Should be able to do this, but NOT!
; SEGMENT         ASMDATA MEMPAGE PUBLIC  'DATA'
SEGMENT         ASMDATA PAGE PUBLIC  'DATA'

                ; must be aligned on a segment boundry
                ALIGN   16
ShrinkTable     DB      39 DUP (0)              ; 0 is my code for spaces.
                DB      27                      ; 27 Code for Apostrophe
                DB      28, 29                  ; Codes for parens
                DB       3 DUP (0)              ; More space filler
                DB      30, 31                  ; Hyphen, Period codes
                DB      18 DUP (0)              ; More filler
                DB      1, 2, 3, 4, 5, 6        ; Here comes the alphabet
                DB      7, 8, 9                 ; A, B, C, D, etc
                DB      10, 11, 12, 13, 14, 15
                DB      16, 17, 18, 19
                DB      20, 21, 22, 23, 24, 25
                DB      26                      ; 26 is Z
                DB      6 DUP (0)
                DB      1, 2, 3, 4, 5, 6        ; lower case translation
                DB      7, 8, 9                 ; A, B, C, D, etc
                DB      10, 11, 12, 13, 14, 15
                DB      16, 17, 18, 19
                DB      20, 21, 22, 23, 24, 25
                DB      26                      ; 26 is Z
                DB      153 DUP (0)             ; yet more filler

                ALIGN   16
UnShrinkTable   DB      32                      ; SPACE
                DB      65, 66, 67, 68, 69, 70  ; A, B, C, D, E, F
                DB      71, 72, 73, 74, 75, 76  ; G, H, I, J, K, L
                DB      77, 78, 79, 80, 81, 82  ; M, N, O, P, Q, R
                DB      83, 84, 85, 86, 87, 88  ; S, T, U, V, W, X
                DB      89, 90                  ; Y, Z
                DB      39, 40, 41, 45, 46      ; '  (  )  -  .

ENDS            ASMDATA

SEGMENT         _AsmStuff Word  Public 'CODE'
                ASSUME cs:_AsmStuff, ds:nothing


EXTRN  C _parclen:PROC
EXTRN  C _parc:PROC
EXTRN  C _xgrab:PROC
EXTRN  C _retclen:PROC
EXTRN  C _xfree:PROC


; setup a TDBreak Point

MACRO           BreakPoint
                int     3
ENDM


;;
;; UDF:     cShrunk := SHRINK (cSource)
;;
;; Input:   cSource a string which contains chars to be shrunk.
;;          It is _ASSUMED_ that the cSource string contains only the
;;          chars A-Z, Space, Apostrophe, Comma, Hypen, Period, OpenParen,
;;          CloseParen.  All values will be treated as a space.
;;          Transformations are done with a table to speed up operation
;;          This results in a larger data segment.  This could be
;;          replaced with a slower, but smaller version.
;;
;; Output:  A string which will be 2/3 the size of cSource
;;

                PUBLIC  SHRINK
PROC            SHRINK          FAR
                LOCAL   DStr  : DATAPTR
                LOCAL   DBuf  : DATAPTR
                LOCAL   Len   : WORD
                LOCAL   TSeg  : WORD
                USES    bp, ds, es, si, di

                mov     ax, 1
                call    _parclen        c, ax
                mov     [Len], ax

                mov     ax, 1
                call    _parc           c, ax
                mov     [WORD PTR DStr], AX
                mov     [WORD PTR DStr+2], DX

                ;       Grab a buffer for our string
                inc     [Len]
                mov     ax, [Len]
                add     ax, 2                   ; Make room for over write
                call    _xgrab          c, ax   ; Membuf at DX:AX
                mov     [WORD PTR DBuf], AX
                mov     [WORD PTR DBuf+2], DX

                ; Save the data segment
                push    ds

                ;       Setup Table Segment
                mov     dx, SEG ShrinkTable
                mov     ax, OFFSET ShrinkTable
                ;       Normalize the pointer
                shr     ax, 4
                add     dx, ax
                mov     [TSeg], dx

                ;       Set up for translation
                lds     si, [DStr]              ; Pointer to str in DS:SI
                mov     cx, [WORD PTR DBuf]     ; Offset of buf in CX
                xor     dx, dx                  ; Len of buf

                ;       Check to see if their is any string to process
                cmp     [Len], 0
                jz      @@All_Done

                BreakPoint

@@Again:
                ;       Process at Pos 1
                ;       While not done Continue
                dec     [Len]
                jz      @@All_Done
                mov     ax, [TSeg]
                mov     es, ax                  ; ES should be table seg
                xor     ax, ax                  ; clean for table read
                xor     bx, bx                  ; clear out dest word
                lodsb                           ; put next char in al
                mov     di, ax
                mov     bl, [BYTE PTR es:di]
                inc     dx

                ;       Process at Pos 2
                ;       While not done Continue
                dec     [Len]
                jz      @@All_Done
                lodsb                           ; get next char
                mov     di, ax                  ; note AH is still zero 
                xor     al, al
                mov     ah, [BYTE PTR es:di]
                shr     ax, 3
                or      bx, ax                  ; add this one in
                inc     dx

                ;       Process at Pos 3
                ;       While not done Continue
                dec     [Len]
                jz      @@All_Done
                lodsb
                xor     ah, ah                  ; zero out high byte
                mov     di, ax
                xor     al, al                  ; zero out low byte
                mov     ah, [BYTE PTR es:di]    ; chk table
                shl     ax, 2
                or      bx, ax

                ;       Save word in buf
                mov     ax, [WORD PTR DBuf+2]   ; get the segment
                mov     es, ax
                mov     di, cx
                mov     [WORD PTR es:di], bx
                inc     cx
                inc     cx

                jmp     @@Again


@@All_Done:
                ;       Save word in buf (should be over write space...
                mov     ax, [WORD PTR DBuf+2]   ; get the segment
                mov     es, ax
                mov     di, cx
                mov     [WORD PTR es:di], bx

                ; Restore the data segment
                pop     ds

                ;       Return the string
                call    _retclen        c, [DBuf], dx

                ;       Give back our allocated memory
                call    _xfree          c, [DBuf]

                ret

ENDP            SHRINK



;;
;; UDF:     cUnShrunk := UnShrink (cSource)
;;
;; Input:   cSource a string which contains chars to be unshrunk.
;;          Transformations are done with a table to speed up operation
;;          This results in a larger data segment.  This could be
;;          replaced with a slower, but smaller version.
;;
;; Output:  A string which will be 2/3 the size of cSource
;;

                PUBLIC  UNSHRINK
PROC            UNSHRINK        FAR
                LOCAL   DStr  : DATAPTR
                LOCAL   DBuf  : DATAPTR
                LOCAL   Len   : WORD
                LOCAL   TSeg  : WORD
                USES    bp, ds, es, si, di

                ;       Get String Length
                mov     ax, 1
                call    _parclen        c, ax
                mov     [Len], ax

                ;       Get String Address
                mov     ax, 1
                call    _parc           c, ax
                mov     [WORD PTR DStr], AX
                mov     [WORD PTR DStr+2], DX

                ;       Grab a buffer for our string
                mov     ax, [Len]
                mov     bx, ax
                shr     ax, 1
                add     ax, bx                  ; ax = ax * 1.5
                mov     [Len], ax
                call    _xgrab          c, ax   ; Membuf at DX:AX
                mov     [WORD PTR DBuf], AX
                mov     [WORD PTR DBuf+2], DX

                ; Save the data segment
                push    ds

                BreakPoint

                ;       Setup Table Segment
                mov     dx, SEG UnShrinkTable
                mov     ax, OFFSET UnShrinkTable
                ;       Normalize the pointer
                shr     ax, 4
                add     dx, ax
                mov     [TSeg], dx

                ;       Set up for translation
                les     di, [DBuf]              ; Pointer to buf in ES:DI
                mov     cx, [WORD PTR DStr]     ; Offset of str in CX
                xor     dx, dx                  ; Len of buf

                ;       Check to see if their is any string to process
                cmp     [Len], 0
                jz      @@All_Done
                inc     [Len]

@@Again:
                ;       Process at Pos 1
                ;       While not done Continue
                dec     [Len]
                jz      @@All_Done
                mov     ax, [WORD PTR DStr+2]   ; Get str segment
                mov     ds, ax
                mov     si, cx                  ; [ds:si] = current word
                lodsw                           ; ax = current word
                mov     cx, si
                mov     bx, ax

                and     ax, 11111b
                mov     si, ax
                mov     ax, [TSeg]
                mov     ds, ax                  ; DS should be table seg
                movsb
                inc     dx

                ;       Process at Pos 2
                ;       While not done Continue
                dec     [Len]
                jz      @@All_Done
                mov     ax, bx
                shr     ax, 5
                and     ax, 11111b
                mov     si, ax
                movsb
                inc     dx

                ;       Process at Pos 3
                ;       While not done Continue
                dec     [Len]
                jz      @@All_Done
                mov     ax, bx
                mov     al, ah          ; same as shr ax, 8 for al (not ah)
                shr     ax, 2           ; finish the job
                and     ax, 11111b      ; should not be necessary
                mov     si, ax
                movsb
                inc     dx

                jmp     @@Again


@@All_Done:

                ; Restore the data segment
                pop     ds

                ;       Return the string
                call    _retclen        c, [DBuf], dx

                ;       Give back our allocated memory
                call    _xfree          c, [DBuf]

                ret

ENDP            UNSHRINK




ENDS            _AsmStuff       ; End of code segment
                END

;;  End of SHRINK.ASM
